package com.gct.driver;

import com.gct.driver.lotpi.ConnectionConfig;
import com.gct.driver.lotpi.DataBit;
import com.gct.driver.lotpi.DataBlock;
import com.gct.driver.lotpi.DataType;
import com.gct.driver.lotpi.extent.Connector;
import com.gct.driver.lotpi.message.WriteCompleted;
import com.gct.driver.modbus.ModbusTcp;
import com.gct.driver.siemens.SiemensS300;

import java.util.Arrays;
import java.util.function.Consumer;

public class Main extends Thread {
    public static void main(String[] args) {


//        TestModbusTCP();

        TestSiemens();
    }

    static void TestModbusTCP() {

        DataBit[] test0 = new DataBit[]{new DataBit(DataType.BOOL, "0001"),
                new DataBit(DataType.BOOL, "0002"),
                new DataBit(DataType.BOOL, "0050"),
                new DataBit(DataType.BOOL, "0002"),
                new DataBit(DataType.BOOL, "02"),
                new DataBit(DataType.BOOL, "00080"),

        };

        DataBit[] test1 = new DataBit[]{
                new DataBit(DataType.BOOL, "1001"),
                new DataBit(DataType.BOOL, "1002"),
                new DataBit(DataType.BOOL, "1050"),
                new DataBit(DataType.BOOL, "1002"),
                new DataBit(DataType.BOOL, "1032"),
                new DataBit(DataType.BOOL, "1080"),

        };

        DataBit[] test3 = new DataBit[]{
                new DataBit(DataType.INT16, "3001"),
                new DataBit(DataType.UINT16, "3003"),
                new DataBit(DataType.INT32, "3005"),
                new DataBit(DataType.UINT32, "3007"),
                new DataBit(DataType.FLOAT, "3009"),
                new DataBit(DataType.DOUBLE, "30011")
        };
        DataBit temp= new DataBit(DataType.BCD, "4001","4002");
//        temp.setDataNumbers((short)3);
        DataBit[] test4 = new DataBit[]{
                new DataBit(DataType.INT64, "40015"),
                temp
        };


        Connector modbus = new ModbusTcp();
        ConnectionConfig config = modbus.parseUrl("modbus-tcp://127.0.0.1:502?station=1&timeout=500&byteOrder=3&pageSize=200");

        modbus.setConfig(config);

        modbus.open();


//        boolean res = modbus.write(new DataBit(DataType.FLOAT, "4009"), 56);
//        res = modbus.write(new DataBit(DataType.INT16, "4001"), -32767);
//        res = modbus.write(new DataBit(DataType.UINT16, "4003"), 20);
//        res = modbus.write(new DataBit(DataType.INT32, "4005"), -655355);
//        res = modbus.write(new DataBit(DataType.UINT32, "4007"), 655355);
//        res = modbus.write(new DataBit(DataType.DOUBLE, "40011"), 565555.5555);
//        res = modbus.write(new DataBit(DataType.INT64, "40015"), 565545645);


//        int[] uint16=new int[]{78978, 1111, 20, 0, -10, 5, 9, -5, 16992, 0, 16673, 16999, 7274, 32506, 0, 0, 8629, -30035, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,4564};
//        res = modbus.write(new DataBit(DataType.UINT16S, "40001"), uint16);
//        short[] int16=new short[]{-5555, 1111, 20, 0, -10, 5, 9, -5, 16992, 0, 16673, 16999, 7274, 32506, 0, 0, 8629, -30035, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,4564};
//        res = modbus.write(new DataBit(DataType.INT16S, "40001"), int16);
        byte[] bcds=new byte[]{2, 0, 2, 1, 0, 0, 0, 4, 0, 0, 0, 2, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 2, 5  };
        modbus.write(new DataBit(DataType.BCD, "40001","40012"), bcds);//BCD 不当array处理
        modbus.write(new DataBit(DataType.BCD, "40001"), bcds);//BCD 两种定义方式皆可
//        DataBlock read0 = modbus.read(test0);
//        DataBlock read1 = modbus.read(test1);
//        DataBlock read3 = modbus.read(test3);
        DataBlock read4 = modbus.read(test4);
//
//        System.out.println(read0.getData(test0[0]));
//        System.out.println(read0.getData(test0[1]));
//        System.out.println(read0.getData(test0[2]));
//        System.out.println(read0.getData(test0[3]));
//        System.out.println(read0.getData(test0[4]));
//        System.out.println(read0.getData(test0[5]));
//
//        System.out.println(read1.getData(test1[0]));
//        System.out.println(read1.getData(test1[1]));
//        System.out.println(read1.getData(test1[2]));
//        System.out.println(read1.getData(test1[3]));
//        System.out.println(read1.getData(test1[4]));
//        System.out.println(read1.getData(test1[5]));
//
//
//        System.out.println(read3.getData(test3[0]));
//        System.out.println(read3.getData(test3[1]));
//        System.out.println(read3.getData(test3[2]));
//        System.out.println(read3.getData(test3[3]));
//        System.out.println(read3.getData(test3[4]));
//        System.out.println(read3.getData(test3[5]));

        System.out.println(read4.getData(test4[0]));


        byte[] resArray=(byte[])read4.getData(test4[1]);
        System.out.println(Arrays.toString(resArray));



    }



    static void TestSiemens() {


        DataBit[] test0 = new DataBit[]{
                new DataBit(DataType.BOOL, "Q0.0"),
                new DataBit(DataType.BOOL, "I0.0"),
                new DataBit(DataType.BOOL, "Q0.1"),
                new DataBit(DataType.BOOL, "M1.1"),
                new DataBit(DataType.BOOL, "M100.0"),
                new DataBit(DataType.BOOL, "V100.1"),
        };
        DataBit[] test1 = new DataBit[]{
                new DataBit(DataType.BYTE, "V100"),
                new DataBit(DataType.INT16, "V102"),
                new DataBit(DataType.UINT16, "V104"),
                new DataBit(DataType.INT32, "V106"),
                new DataBit(DataType.UINT32, "V110"),
                new DataBit(DataType.FLOAT, "V114"),
                new DataBit(DataType.FLOAT, "V118"),
        };
        DataBit[] test2 = new DataBit[]{
                new DataBit(DataType.BYTE, "DB1.100"),
                new DataBit(DataType.INT16, "DB1.102"),
                new DataBit(DataType.UINT16, "DB1.104"),
                new DataBit(DataType.INT32, "DB1.106"),
                new DataBit(DataType.UINT32, "DB1.110"),
                new DataBit(DataType.FLOAT, "DB1.114"),
                new DataBit(DataType.FLOAT, "DB1.118"),
        };
        DataBit temp= new DataBit(DataType.UINT16, "DB1.0","DB1.024");
        DataBit[] test4 = new DataBit[]{
                new DataBit(DataType.INT64, "DB2.0"),
                temp
        };


        Connector siemens = new SiemensS300();
        ConnectionConfig config = siemens.parseUrl("siemens-s300://127.0.0.1:102?timeout=500&byteOrder=3&rack=0&slot=2");
        siemens.setConfig(config);

        siemens.open();


//        boolean res = siemens.write(test1[0], 23);
//        res = siemens.write(test1[1], 46);
//        res = siemens.write(test1[2], 89);
//        res = siemens.write(test1[3], 555);
//        res = siemens.write(test1[4], 7897);
//        res = siemens.write(test1[5], 555.899);
//
//        res = siemens.write(test2[0], 23);
//        res = siemens.write(test2[1], 46);
//        res = siemens.write(test2[2], 89);
//        res = siemens.write(test2[3], 555);
//        res = siemens.write(test2[4], 7897);
//        res = siemens.write(test2[5], 555.899);

//        siemens.asyncWriteBatch(new DataBit[]{new DataBit(DataType.FLOAT, "DB1.200")}, new Object[]{22.22}, new Consumer<WriteCompleted>() {
//            @Override
//            public void accept(WriteCompleted writeCompleted) {
//                System.out.println(writeCompleted);
//            }
//        });
        int[] uint16=new int[]{65534, 1111, 20, 0, -10, 5, 9, -5, 16992, 0, 16673, 16999, 7274, 32506, 0, 0, 8629, -30035, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,4564};
        siemens.write(new DataBit(DataType.UINT16, "DB1.0"), uint16);
//        short[] int16=new short[]{-5555, 1111, 20, 0, -10, 5, 9, -5, 16992, 0, 16673, 16999, 7274, 32506, 0, 0, 8629, -30035, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,4564};
//        res = modbus.write(new DataBit(DataType.INT16S, "40001"), int16);

//        byte[] bcds=new byte[]{2, 0, 2, 1, 0, 0, 0, 4, 0, 0, 0, 2, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 2, 5  };
//        siemens.write(new DataBit(DataType.BCDS, "DB1.0"), bcds);

//        DataBlock read0 = siemens.read(test0);
//        DataBlock read1 = siemens.read(test1);
//        DataBlock read2 = siemens.read(test2);
//      DataBlock read3 = siemens.read(test3);
      DataBlock read4 = siemens.read(test4);

//        System.out.println(read0.getData(test0[0]));
//        System.out.println(read0.getData(test0[1]));
//        System.out.println(read0.getData(test0[2]));
//        System.out.println(read0.getData(test0[3]));
//        System.out.println(read0.getData(test0[4]));
//        System.out.println(read0.getData(test0[5]));
//
//        System.out.println(Byte.parseByte(read1.getData(test1[0]).toString()));
//        System.out.println(read1.getData(test1[1]));
//        System.out.println(read1.getData(test1[2]));
//        System.out.println(read1.getData(test1[3]));
//        System.out.println(read1.getData(test1[4]));
//        System.out.println(read1.getData(test1[5]));
//
//        System.out.println(Byte.parseByte(read2.getData(test2[0]).toString()));
//        System.out.println(read2.getData(test2[1]));
//        System.out.println(read2.getData(test2[2]));
//        System.out.println(read2.getData(test2[3]));
//        System.out.println(read2.getData(test2[4]));
//        System.out.println(read2.getData(test2[5]));
//
//
//      System.out.println(read3.getData(test3[0]));
//      System.out.println(read3.getData(test3[1]));
//      System.out.println(read3.getData(test3[2]));
//      System.out.println(read3.getData(test3[3]));
//      System.out.println(read3.getData(test3[4]));
//      System.out.println(read3.getData(test3[5]));
//
        System.out.println(read4.getData(test4[0]));


        int[] resArray=(int[])read4.getData(test4[1]);
        System.out.println(Arrays.toString(resArray));
//      System.out.println(read4.getData(test4[2]));
//      System.out.println(read4.getData(test4[3]));
//      System.out.println(read4.getData(test4[4]));
//      System.out.println(read4.getData(test4[5]));
//      System.out.println(read4.getData(test4[6]));

    }


}


