package com.gct.driver.core;

import com.gct.driver.lotpi.DataBit;
import com.gct.driver.lotpi.DataBlock;

import java.util.HashMap;


public final class BasicDataBlock extends DataBlock {
    private HashMap<DataBit, BasicDataBit> innerMap;

    public BasicDataBlock(HashMap<DataBit, BasicDataBit> realData) {
        innerMap = realData;

    }

    public Object getData(DataBit dataBit) {

        return innerMap.get(dataBit).getValue();
    }


    public Integer getInt(DataBit dataBit) {
        return Integer.parseInt(innerMap.get(dataBit).getValue().toString());

    }

    public String getString(DataBit dataBit) {
        return innerMap.get(dataBit).getValue().toString();
    }

    public Double getDouble(DataBit dataBit) {
        return Double.parseDouble(innerMap.get(dataBit).getValue().toString());
    }

    @Deprecated
    private String generateKey(DataBit dataBit) {
        return dataBit.getBitAddress().toString() + "_" + dataBit.getTypeDefine().toString();
    }
}