package com.gct.driver.core.net;

import com.gct.driver.core.INetMessage;
import com.gct.driver.core.transfer.IByteTransform;


/**
 * 设备类的基类，提供了基础的字节读写方法，采用泛型继承实现
 * @param <TNetMessage> 消息类型
 * @param <TTransform> 变换类型
 */
public class NetworkDeviceBase<TNetMessage extends INetMessage,TTransform extends IByteTransform> extends NetworkDoubleBase<TNetMessage,TTransform>
{

    public NetworkDeviceBase(Class<TNetMessage> netMessageClass, Class<TTransform> tTransformClass){
        super(netMessageClass, tTransformClass);
    }

    /**************************************************************************************************
     *
     *    说明：子类中需要重写基础的读取和写入方法，来支持不同的数据访问规则
     *
     *    此处没有将读写位纳入进来，因为各种设备的支持不尽相同，比较麻烦
     *
     **************************************************************************************************/

    protected short WordLength = 1;


    /**
     * 返回表示当前对象的字符串
     * @return 字符串数据
     */
    @Override
    public String toString() {
        return "NetworkDeviceBase<TNetMessage, TTransform>";
    }

}
