package com.gct.driver.core.transfer;

/**
 * 应用于多字节数据的解析或是生成格式
 */
public enum DataFormat {
    /**
     * 按照顺序的格式生成的解析规则
     */
    ABCD(0),
    /**
     * 按照单字反转
     */
    BADC(1),
    /**
     * 按照双字反转
     */
    CDAB(2),
    /**
     * 按照倒序排序
     */
    DCBA(3);

    DataFormat(int id) {
        this.id = id;
    }

    private int id;


    public static DataFormat valueOf(int id) {
        for (DataFormat value : DataFormat.values()) {
            if (value.id == id) return value;
        }
        return ABCD;
    }
}
