package com.gct.driver.modbus;

import com.gct.driver.core.BasicDataBit;
import com.gct.driver.core.Utilities;
import com.gct.driver.core.ValueType;
import com.gct.driver.lotpi.DataBit;
import com.gct.driver.lotpi.DataType;
import com.gct.driver.lotpi.exception.UnsupportedType;

/**
 * dec:
 * <p>
 * ModbusTypeLengthDefine
 * </p>
 *
 * @author lloyd
 * @version 1.0.1
 * @since 2022/8/18 下午3:53
 */
public class ModbusValueType implements ValueType {

    @Override
    public float byteLength(DataType type) {
        switch (type) {
            case UINT32:
            case FLOAT:
            case INT32:
                return 2;
            case DOUBLE:
            case INT64:
                return 4;
            case BCD:
                return 0.25f;
            case BOOL:
            case BYTE:
            case UINT16:
            case INT16:
            case STRING:
                return 1;
            default:
                throw new UnsupportedType();
        }
    }

    @Override
    public int valTotal(DataType type, Object low, Object high) {
        if (Utilities.IsNullOrEmpty(low) || Utilities.IsNullOrEmpty(high)) return 0;
        float v = (Integer.parseInt(high.toString()) - Integer.parseInt(low.toString())) / byteLength(type);
        if (v <= 0) return 0;
        return (int) v + 1;
    }

}
