package com.gct.driver.siemens;

import com.gct.driver.core.Utilities;
import com.gct.driver.core.ValueType;
import com.gct.driver.lotpi.DataType;
import com.gct.driver.lotpi.exception.UnsupportedType;

/**
 * dec:
 * <p>
 * SiemensValueType
 * </p>
 *
 * @author lloyd
 * @version 1.0.1
 * @since 2022/8/19 上午11:47
 */
public class SiemensValueType implements ValueType {
    @Override
    public float byteLength(DataType type) {
        switch (type) {
            case UINT32:
            case FLOAT:
            case INT32:
                return 4;
            case DOUBLE:
            case INT64:
                return 8;
            case BCD:
                return 0.5f;
            case UINT16:
            case INT16:
                return 2;
            case BOOL:
            case BYTE:
            case STRING:
                return 1;
            default:
                throw new UnsupportedType();
        }
    }

    @Override
    public int valTotal(DataType type, Object low, Object high) {
        if (Utilities.IsNullOrEmpty(low) || Utilities.IsNullOrEmpty(high)) return 0;
        return (int) ((Integer.parseInt(formatAddress(high)) - Integer.parseInt(formatAddress(low))) / byteLength(type)) + 1;
    }

    private String formatAddress(Object address) {
        return address.toString().replaceAll(".*\\.", "").replaceAll("^[a-zA-Z]*", "");
    }
}
